/***********************************************************
Copyright 1990 by Digital Equipment Corporation, Maynard, Massachusetts.

                        All Rights Reserved

Permission to use, copy, modify, and distribute these examples for any
purpose and without fee is hereby granted, provided that the above
copyright notice appear in all copies and that both that copyright
notice and this permission notice appear in supporting documentation,
and that the name of Digital not be used in advertising or publicity
pertaining to distribution of the software without specific, written
prior permission.

DIGITAL AND THE AUTHORS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS, IN NO EVENT SHALL DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT
OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE
OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE
OR PERFORMANCE OF THIS SOFTWARE.

******************************************************************/

/* Make it safe to include this file more than once. */

#ifndef MENUP_H
#define MENUP_H

/* Include the public header file for Menu */

#include "Menu.h"

/* Menu is derived from Constraint, so no need to include the
   superclass private header file.  */

/* Define the Menu instance part */

typedef struct {
    long	save_border;	/* For geometry request foolishness */
} MenuPart;

/* Define the full instance record */

typedef struct _MenuRec {
    CorePart		core;
    CompositePart	composite;
    ConstraintPart	constraint;
    MenuPart		menu;
} MenuRec;

/* Define class part structure */

typedef struct {
    XtPointer		extension;
} MenuClassPart;

/* Define the full class record */

typedef struct _MenuClassRec {
    CoreClassPart	core_class;
    CompositeClassPart	composite_class;
    ConstraintClassPart	constraint_class;
    MenuClassPart	menu_class;
} MenuClassRec, *MenuClass;

/* Define constraint part structure */

typedef struct {
  /* New resource field */
    Widget		insert_before;	/* Widget to insert before */

  /* New bookkeeping fields */
    Dimension		desired_height;
    Dimension		desired_border_width;
} MenuConstraintPart;

/* Define the full constraint record */

typedef struct _MenuConstraintRec {
    MenuConstraintPart	menu;
} MenuConstraintRec, *MenuConstraint;

/* External definition for class record */

extern MenuClassRec menuClassRec;

/* End of preprocessor directives */

#endif /* MENUP_H */

